<template>
    <div class='edit-popup'>
        <popup
            ref='popupRef'
            :title='popupTitle'
            :async='true'
            width='60%'
            @confirm='handleSubmit'
            @close='handleClose'
        >
            <el-form ref='formRef' :model='formData' label-width='90px' :rules='formRules'>
                <el-form-item label='试题分类' prop='category_uid'>
                    <el-cascader
                        v-model='formData.category_uid'
                        :options='optionsData.category'
                        :props='props'
                        @change='handleChange'
                        style='width: 100%'
                    />
                </el-form-item>
                <el-form-item label='试题题干' prop='title'>
                    <el-input v-model='formData.title' clearable placeholder='请输入试题题干' />
                </el-form-item>
                <el-form-item label='正确选项' prop='option1'>
                    <el-input v-model='formData.option1' clearable placeholder='请输入试题题干' />
                </el-form-item>
                <el-form-item label='错误选项' prop='option2'>
                    <el-input v-model='formData.option2' clearable placeholder='请输入试题题干' />
                </el-form-item>
                <el-form-item label='答案选项' required prop='is_correct'>
                    <el-radio-group v-model='formData.is_correct'>
                        <el-radio :label='1'>正确</el-radio>
                        <el-radio :label='2'>错误</el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label='试题积分' prop='score'>
                    <el-input-number
                        v-model='formData.score'
                        clearable
                        placeholder='请输入试题积分'
                        :precision='2'
                        :step='0.1'
                        :max='100'
                    />
                </el-form-item>
                <el-form-item label='显示状态' prop='is_show'>
                    <el-radio-group v-model='formData.is_show' placeholder='请选择显示状态'>
                        <el-radio
                            v-for='(item, index) in dictData.show_status'
                            :key='index'
                            :label='parseInt(item.value)'
                        >
                            {{ item.name }}
                        </el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label='显示权重' prop='sort'>
                    <div>
                        <el-input-number v-model='formData.sort' :min='0' />
                        <div class='form-tips'>默认为0， 数值越大越排前</div>
                    </div>
                </el-form-item>
                <el-form-item label="试题难度" prop="level">
                    <el-select
                        class="flex-1"
                        v-model="formData.level"
                        clearable
                        placeholder="请选择试题难度"
                    >
                        <el-option
                            v-for="(item, index) in dictData.exam_level"
                            :key="index"
                            :label="item.name"
                            :value="parseInt(item.value)"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label='试题解析' prop='analysis'>
                    <editor class='flex-1' v-model='formData.analysis' :height='auto' />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang='ts' setup name='examJudeEdit'>
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiExamJudeAdd, apiExamJudeDetail, apiExamJudeEdit } from '@/api/exam_jude'
import type { PropType } from 'vue'
import { useDictData, useDictOptions } from '@/hooks/useDictOptions'
import { apiExamCategoryTree } from '@/api/exam_category'

defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')

// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑判断试题' : '新增判断试题'
})

// 表单数据
const formData = reactive({
    id: '',
    category_uid: '',
    title: '',
    option1: '正确',
    option2: '错误',
    score: 1,
    is_correct: '',
    analysis: '',
    sort: 0,
    is_show: 1,
    level: ''
})

// 表单验证
const formRules = reactive<any>({
    title: [
        {
            required: true,
            message: '请输入试题题干',
            trigger: ['blur']
        }
    ],
    option1: [
        {
            required: true,
            message: '请输入试题选项1',
            trigger: ['blur']
        }
    ],
    option2: [
        {
            required: true,
            message: '请输入试题选项2',
            trigger: ['blur']
        }
    ],
    is_correct: [
        {
            required: true,
            message: '请选择试题答案项',
            trigger: ['blur']
        }
    ],
    score: [
        {
            required: true,
            message: '请输入试题积分',
            trigger: ['blur']
        }
    ],
    sort: [
        {
            required: true,
            message: '请输入显示权重',
            trigger: ['blur']
        }
    ],
    is_show: [
        {
            required: true,
            message: '请选择显示状态',
            trigger: ['blur']
        }
    ],
    level: [
        {
            required: true,
            message: '请选择试题难度',
            trigger: ['blur']
        }
    ],
})

// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
}

const { dictData } = useDictData('show_status,free_status,exam_level')


const getDetail = async (row: Record<string, any>) => {
    const data = await apiExamJudeDetail({
        id: row.id
    })
    setFormData(data)
}

const { optionsData } = useDictOptions<{
    category: any[]
}>({
    category: {
        api: apiExamCategoryTree
    }
})

const handleChange = (value) => {
    formData.category_uid = value[1]
}

// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData }
    mode.value == 'edit' ? await apiExamJudeEdit(data) : await apiExamJudeAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}

defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
